//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Wed Jul 30 10:18:28 2008 by ROOT version 5.18/00a
// from TTree MCInfo/MC Info
// found on file: signalMC.root
//////////////////////////////////////////////////////////

#ifndef GenInfo_h
#define GenInfo_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>

class GenInfo {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leaf types
   Int_t           Event;
   Int_t           Run;
   Int_t           mcID_lab0;
   Float_t         mcp_lab0;
   Float_t         mcpt_lab0;
   Float_t         mcpx_lab0;
   Float_t         mcpy_lab0;
   Float_t         mcpz_lab0;
   Float_t         mctau_lab0;
   Int_t           mcID_lab1;
   Float_t         mcp_lab1;
   Float_t         mcpt_lab1;
   Float_t         mcpx_lab1;
   Float_t         mcpy_lab1;
   Float_t         mcpz_lab1;
   Float_t         mctau_lab1;

   // List of branches
   TBranch        *b_Event;   //!
   TBranch        *b_Run;   //!
   TBranch        *b_mcID_lab0;   //!
   TBranch        *b_mcp_lab0;   //!
   TBranch        *b_mcpt_lab0;   //!
   TBranch        *b_mcpx_lab0;   //!
   TBranch        *b_mcpy_lab0;   //!
   TBranch        *b_mcpz_lab0;   //!
   TBranch        *b_mctau_lab0;   //!
   TBranch        *b_mcID_lab1;   //!
   TBranch        *b_mcp_lab1;   //!
   TBranch        *b_mcpt_lab1;   //!
   TBranch        *b_mcpx_lab1;   //!
   TBranch        *b_mcpy_lab1;   //!
   TBranch        *b_mcpz_lab1;   //!
   TBranch        *b_mctau_lab1;   //!

   GenInfo(TTree *tree=0);
   virtual ~GenInfo();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
};

#endif

#ifdef GenInfo_cxx
GenInfo::GenInfo(TTree *tree)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("signalMC.root");
      if (!f) {
         f = new TFile("signalMC.root");
      }
      tree = (TTree*)gDirectory->Get("MCInfo");

   }
   Init(tree);
}

GenInfo::~GenInfo()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t GenInfo::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t GenInfo::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (!fChain->InheritsFrom(TChain::Class()))  return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void GenInfo::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("Event", &Event, &b_Event);
   fChain->SetBranchAddress("Run", &Run, &b_Run);
   fChain->SetBranchAddress("mcID_lab0", &mcID_lab0, &b_mcID_lab0);
   fChain->SetBranchAddress("mcp_lab0", &mcp_lab0, &b_mcp_lab0);
   fChain->SetBranchAddress("mcpt_lab0", &mcpt_lab0, &b_mcpt_lab0);
   fChain->SetBranchAddress("mcpx_lab0", &mcpx_lab0, &b_mcpx_lab0);
   fChain->SetBranchAddress("mcpy_lab0", &mcpy_lab0, &b_mcpy_lab0);
   fChain->SetBranchAddress("mcpz_lab0", &mcpz_lab0, &b_mcpz_lab0);
   fChain->SetBranchAddress("mctau_lab0", &mctau_lab0, &b_mctau_lab0);
   fChain->SetBranchAddress("mcID_lab1", &mcID_lab1, &b_mcID_lab1);
   fChain->SetBranchAddress("mcp_lab1", &mcp_lab1, &b_mcp_lab1);
   fChain->SetBranchAddress("mcpt_lab1", &mcpt_lab1, &b_mcpt_lab1);
   fChain->SetBranchAddress("mcpx_lab1", &mcpx_lab1, &b_mcpx_lab1);
   fChain->SetBranchAddress("mcpy_lab1", &mcpy_lab1, &b_mcpy_lab1);
   fChain->SetBranchAddress("mcpz_lab1", &mcpz_lab1, &b_mcpz_lab1);
   fChain->SetBranchAddress("mctau_lab1", &mctau_lab1, &b_mctau_lab1);
   Notify();

   //   TH1F *taugen = new TH1F("taugen","Generated propertime",10,0.0,5.0);
}

Bool_t GenInfo::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void GenInfo::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t GenInfo::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef GenInfo_cxx
